!> @file
!!  Wrapper around some libXC library routines
!!   in order to maintain backward compatibility
!! @author
!!    Copyright (C) 2017-2017 ABINIT group (MTorrent)
!!    This file is distributed under the terms of the
!!    GNU General Public License, see ~/COPYING file
!!    or http://www.gnu.org/copyleft/gpl.txt .
!!    For the list of contributors, see ~/AUTHORS

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

#include "xc_version.h"

module libxc_wrap

  use xc_f90_types_m
  use libxc_funcs_m

  public :: xc_f90_info_refs_wrapper

contains

!------------------------------------------------------------
! --- COMPATIBLE WITH LIBXC V3+
!------------------------------------------------------------
#ifdef XC_MICRO_VERSION
subroutine xc_f90_info_refs_wrapper(xc_info, ii, name)

 implicit none
 type(xc_f90_pointer_t), intent(in) :: xc_info
 integer, intent(inout) :: ii
 character(len = *), intent(out) :: name

!This one is compatible with libXC v3+
 call xc_f90_info_refs(xc_info,ii,name)

end subroutine xc_f90_info_refs_wrapper


!------------------------------------------------------------
! --- COMPATIBLE WITH LIBXC V2
!------------------------------------------------------------
#else

subroutine xc_f90_info_refs_wrapper(xc_info, ii, name)

 implicit none
 type(xc_f90_pointer_t), intent(in) :: xc_info
 integer, intent(inout) :: ii
 character(len = *), intent(out) :: name

 type(xc_f90_pointer_t) :: str

!This one is compatible with libXC v2
 call xc_f90_info_refs(xc_info,ii,str,name)

end subroutine xc_f90_info_refs_wrapper

#endif

end module libxc_wrap
